import {ValidationErrorTypeEnum} from './ValidationErrorTypeEnum';
import {ValidationRule} from './ValidationRule';

export class ValidationError extends Error {

    private errorType:ValidationErrorTypeEnum;
    private rule:ValidationRule;
    private value:string;

    constructor(errorType:ValidationErrorTypeEnum,
                rule:ValidationRule,
                value:string,
                message?:string) {
        super(message);

        this.rule = rule;
        this.value = value;
        this.errorType = errorType;
    }

    public getRule():ValidationRule {
        return this.rule;
    }

    public getErrorType():ValidationErrorTypeEnum {
        return this.errorType;
    }

    public getValue():string {
        return this.value;
    }
}
