export class ValidationRule {

    private _pattern:string;
    private _errorMessage:string;

    private _maxLength:number;
    private _minLength:number;

    private _allowBlank:boolean;

    constructor(pattern:string, errorMessage?:string) {
        this._pattern = pattern;
        this._errorMessage = errorMessage;
        this._allowBlank = false;
    }

    public getPattern():string {
        return this._pattern;
    }

    public getErrorMessage():string {
        return this._errorMessage;
    }

    public getMaxLength():number {
        return this._maxLength;
    }

    public getMinLength():number {
        return this._minLength;
    }

    public hasMaxLength():boolean {
        return typeof this._maxLength !== "undefined";
    }

    public hasMinLength():boolean {
        return typeof this._minLength !== "undefined";
    }

    public isAllowBlank() {
        return this._allowBlank;
    }

    public maxLength(maxLength:number):ValidationRule {
        this._maxLength = maxLength;
        return this;
    }

    public minLength(minLength:number):ValidationRule {
        this._minLength = minLength;
        return this;
    }

    public allowBlank() {
        this._allowBlank = true;
    }
}
